<?
	include 'config.inc';
	include 'template.inc';
	include 'funcs.inc';

	session_start();
	session_register('found_songs');										/* songs found, name => size */
	session_register('selected_songs');										/* songs selected, name => size */
	session_register('total_size');
	session_register('list_data');
	$total_size = 1;

	if (!isset($found_songs)) $found_songs = '';
	if (!isset($list_data)) $list_data = '';
	$mp3_count = '';
	$album_count = '';
	$songs = '';

	if (count($found_songs) < 2) {
	foreach ($dirs as $dir) {
		$fd = @opendir($dir);

		if ($fd == false)
			continue;

		while ($album = readdir($fd)) {

			foreach ($bad_files as $bad)
				if ($album == $bad)
					continue 2;

			if (is_dir("$dir/$album"))
				$album_size = dirsize("$dir/$album");
			else {
				if (!preg_match_all("'.mp3$'", $album, $devnull))			/* if it aint an mp3 or dir, we dont want it */
					continue;
				$album_size = filesize("$dir/$album");
			}

			if ($album_size < 4097)											/* doesnt sound like an mp3 to me */
				continue;

			$mp3_count++;

			$human_size = humanify($album_size);

			$found_songs = array_merge($found_songs, array($album => $album_size));

			$encoded_album = rawurlencode($album);

			$encoded_dir = rawurlencode($dir);

			if (!isset($HTTP_GET_VARS['album'])) {
				if (is_dir("$dir/$album"))
					$list_data .= "<a href=\"index.php?album=$encoded_album&album_size=$album_size&dir=$encoded_dir&checked=no\">$album [$human_size]</a><br>\n";
				else
					$list_data .= "<input type=checkbox name=$encoded_album value=$album_size> $album [$human_size]<br>\n";
			}

			if (isset($HTTP_POST_VARS['album']))
				$selected_songs = array_merge($selected_songs, array($album => $album_size));
		}

		closedir($fd);
	}
	}
	
	if (@$HTTP_GET_VARS['checked'] == 'yes')
		$checked = 'checked';
	else
		$checked = '';

	if (!isset($HTTP_GET_VARS['album']))
		display_main_page();
	else {
		$album_extended = $HTTP_GET_VARS['album'];
		$path = $HTTP_GET_VARS['dir'] . '/' . $HTTP_GET_VARS['album'];
		$songs .= populate_songs("$path");
		display_expanded_page();
	}

	function display_main_page() {

		global $list_data, $mp3_count, $version, $author;

		$template = new template('.');
		$template->set_file('FileHandle', 'index.tpl');
		$template->set_var('list_data', $list_data);
		$template->set_var('mp3_count', preg_match_all("'<br>'", $list_data, $devnull)); /* Kludge? No way! :) */
		$template->set_var('version', $version);
		$template->set_var('author', $author);
		$template->parse('Parsed', 'FileHandle');
		$template->p('Parsed');
	}

	function display_expanded_page() {

		global $HTTP_GET_VARS, $album_extended, $songs, $author;

		$encoded_album = rawurlencode($HTTP_GET_VARS['album']);
		$album_size = $HTTP_GET_VARS['album_size'];
		$dir = rawurlencode($HTTP_GET_VARS['dir']);

		$template = new template('.');
		$template->set_file('FileHandle', 'expanded.tpl');
		$template->set_var('album', $HTTP_GET_VARS['album']);
		$template->set_var('album_extended', $album_extended);
		$template->set_var('songs', $songs);
		$template->set_var('select_all', "index.php?album=$encoded_album&album_size=$album_size&dir=$dir&checked=yes");
		$template->set_var('album_size', humanify($HTTP_GET_VARS['album_size']));
		$template->set_var('author', $author);
		$template->parse('Parsed', 'FileHandle');
		$template->p('Parsed');
	}

	function populate_songs($directory) {

		global $bad_files, $found_songs, $checked;

		$song_list = '';

		$fd = @opendir($directory);

		if ($fd == false)
			return 0;

		while ($song = readdir($fd)) {

			foreach ($bad_files as $bad)
				if (($song == $bad) || (!preg_match('/.mp3$/i', $song))) {
					continue 2;
				}

			$found_songs = array_merge($found_songs, array($song => 0));

			$encoded_song = rawurlencode("$directory/$song");
			$filesize = filesize("$directory/$song");

			$song_list .= "<li><input type=checkbox $checked name=\"$encoded_song\" value=$filesize> $song<br>\n";

		}

		return $song_list;

	}

?>
